#pragma once
/************************************************************************
**
** Authors:   Nils Schimmelmann <nschimme@gmail.com>
**
** This file is part of the MMapper project.
** Maintained by Nils Schimmelmann <nschimme@gmail.com>
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the:
** Free Software Foundation, Inc.
** 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**
************************************************************************/

#ifndef MMAPPER_FORMAT_FLAGS_H
#define MMAPPER_FORMAT_FLAGS_H

#include <cstdint>

enum class FontFormatFlags { NONE = 0, ITALICS = (1 << 0), UNDERLINE = (1 << 1) };
static inline FontFormatFlags operator&(FontFormatFlags lhs, FontFormatFlags rhs)
{
    return static_cast<FontFormatFlags>(static_cast<uint32_t>(lhs) & static_cast<uint32_t>(rhs));
}

#endif // MMAPPER_FORMAT_FLAGS_H
